version: "3.8"

services:
  sos:
    image: registry.gitlab.com/empaia/services/shout-out-service
    restart: ${COMPOSE_RESTART}
    build:
      context: .
    depends_on:
      - sos-db
    environment:
      SOS_ROOT_PATH: ${SOS_ROOT_PATH}
      SOS_DISABLE_OPENAPI: "False"
      SOS_CORS_ALLOW_CREDENTIALS: ${SOS_CORS_ALLOW_CREDENTIALS}
      SOS_CORS_ALLOW_ORIGINS: ${SOS_CORS_ALLOW_ORIGINS}
      SOS_API_V1_INTEGRATION: ${SOS_API_V1_INTEGRATION}
      SOS_DEBUG: ${SOS_DEBUG}
      SOS_DB_HOST: sos-db
      SOS_DB_PORT: 5432
      SOS_DB_USERNAME: ${SOS_DB_USERNAME}
      SOS_DB_PASSWORD: ${SOS_DB_PASSWORD}
      SOS_DB: ${SOS_DB}
      SOS_ENABLE_SINK_AMQP: ${SOS_ENABLE_SINK_AMQP}
      SOS_AMQP_HOST: ${SOS_AMQP_HOST}
      SOS_AMQP_USERNAME: ${SOS_AMQP_USERNAME}
      SOS_AMQP_PASSWORD: ${SOS_AMQP_PASSWORD}
      SOS_IDP_URL: ${SOS_IDP_URL}
      SOS_AUDIENCE: ${SOS_AUDIENCE}
      PYTHONUNBUFFERED: 1
      NO_PROXY: mailhog
    command: run.sh --host=0.0.0.0 --port=8000
    ports:
      - 127.0.0.1:${COMPOSE_SOS_PORT}:8000
    volumes:
      - ${COMPOSE_SOS_RSA_MOUNT}:/opt/app/bin/rsa

  sosd:
    image: registry.gitlab.com/empaia/services/shout-out-service
    restart: ${COMPOSE_RESTART}
    build:
      context: .
    depends_on:
      - sos-db
    environment:
      SOS_DEBUG: ${SOS_DEBUG}
      SOS_DB_HOST: sos-db
      SOS_DB_PORT: 5432
      SOS_DB_USERNAME: ${SOS_DB_USERNAME}
      SOS_DB_PASSWORD: ${SOS_DB_PASSWORD}
      SOS_DB: ${SOS_DB}
      SOS_DAEMON_POLL_INTERVAL: ${SOS_DAEMON_POLL_INTERVAL}
      SOS_ENABLE_SINK_SMTP: ${SOS_ENABLE_SINK_SMTP}
      SOS_SMTP_MESSAGE_FROM: ${SOS_SMTP_MESSAGE_FROM}
      SOS_SMTP_HOST: ${SOS_SMTP_HOST}
      SOS_SMTP_PORT: ${SOS_SMTP_PORT}
      SOS_ENABLE_SINK_AMQP: ${SOS_ENABLE_SINK_AMQP}
      SOS_AMQP_HOST: ${SOS_AMQP_HOST}
      SOS_AMQP_USERNAME: ${SOS_AMQP_USERNAME}
      SOS_AMQP_PASSWORD: ${SOS_AMQP_PASSWORD}
      PYTHONUNBUFFERED: 1
      NO_PROXY: mailhog
    command: rund.sh
    volumes:
      - ${COMPOSE_SOS_RSA_MOUNT}:/opt/app/bin/rsa
    ports:
      - 127.0.0.1:5556:5556

  sos-db:
    image: docker.io/postgres:14@sha256:c0e14efd7eaf4d83e443b6e7047ddde6465edbbbcc28ae770d9f5398abba1969
    restart: ${COMPOSE_RESTART}
    environment:
      POSTGRES_USER: ${SOS_DB_USERNAME}
      POSTGRES_PASSWORD: ${SOS_DB_PASSWORD}
      POSTGRES_DB: ${SOS_DB}
    ports:
      #- 127.0.0.1:${COMPOSE_SOS_DB_PORT}:5432
      - 0.0.0.0:${COMPOSE_SOS_DB_PORT}:5432
    volumes:
      - ${COMPOSE_SOS_DB_MOUNT}:/var/lib/postgresql/data:rw

  mailhog:
    image: docker.io/mailhog/mailhog:latest@sha256:8d76a3d4ffa32a3661311944007a415332c4bb855657f4f6c57996405c009bea
    restart: ${COMPOSE_RESTART}
    ports:
      #- 127.0.0.1:${COMPOSE_MAILHOG_SMTP_PORT}:1025 # smtp server
      - 0.0.0.0:${COMPOSE_MAILHOG_UI_PORT}:8025 # web ui

  rabbitmq:
    image: docker.io/rabbitmq:4-management@sha256:538974614196605a62c8cfb5bd7724dda6d491f026642f2e77b541596526255b
    restart: ${COMPOSE_RESTART}
    environment:
      RABBITMQ_DEFAULT_USER: ${SOS_AMQP_USERNAME}
      RABBITMQ_DEFAULT_PASS: ${SOS_AMQP_PASSWORD}
    volumes:
      - ${COMPOSE_RABBITMQ_MOUNT}:/var/lib/rabbitmq
    ports:
      - 0.0.0.0:${COMPOSE_RABBITMQ_WEB_PORT}:15672
      - 127.0.0.1:${COMPOSE_AMQP_PORT}:5672

volumes:
  sos-db-vol:
    name: sos-db-vol
    external: False
  sos-rsa-vol:
    name: sos-rsa-vol
    external: False
  rabbitmq-vol:
    name: rabbitmq-vol
    external: False
